#include <gtk/gtk.h>

#include <stdio.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include "create_entry_field.h"

#include "function_prototypes.h"

GtkWidget *
create_login_screen		(GList	*g_cols,GtkWidget	*container,
	TABLE *login_table)
{
    int list_length;
    int i;

    /* g_table is where the soon to be created entry_field are to be placed */
    GtkWidget	*g_table;
    GtkWidget	*align;
    GtkWidget	*h_box;
    GtkWidget	*button;

    COLUMN	*col;
    COLUMN	*col2;

    col = (COLUMN *)malloc(sizeof(COLUMN));

    strcpy(col->name,"Profile Name");

    col2 = g_cols->data;

    strcpy(col->parent_name,col2->parent_name);

    col->table = login_table;

    col->type = DBUI_VARCHAR;

    list_length = g_list_length (g_cols);

    if(! list_length)
	return NULL;

    g_table = gtk_table_new (list_length + 3, 3 , FALSE );

    gtk_table_set_row_spacings(GTK_TABLE(g_table), 5);

    gtk_table_set_col_spacings(GTK_TABLE(g_table), 5);

    create_entry_field ( col , (GtkTable *) g_table, 1);

    for(i = 2; g_cols  ; i++)
	{
	/* if we still have a column create an entry for it */
	if( g_cols && g_cols->data )
		create_entry_field ((COLUMN *) g_cols->data , 
				(GtkTable *) g_table, i);
	g_cols = g_list_next (g_cols);
	}

    h_box = gtk_hbox_new( TRUE , 0);

    align = gtk_alignment_new(0.2,0.05,0,0);

    gtk_object_set_data(GTK_OBJECT(g_table),"my_hbox",h_box);

    button = gtk_button_new_with_label("Login");

    gtk_object_set_data(GTK_OBJECT(h_box),"login_button",button);

    gtk_box_pack_start(GTK_BOX(h_box), button , 0, TRUE , 0);

    gtk_signal_connect(GTK_OBJECT(button),"clicked",
		GTK_SIGNAL_FUNC(login),align);

    button = gtk_button_new_with_label("Clear");

    gtk_object_set_data(GTK_OBJECT(h_box),"clear_button",button);

    gtk_signal_connect(GTK_OBJECT(button),"clicked",
		GTK_SIGNAL_FUNC(clear_table),g_table);

    gtk_box_pack_end(GTK_BOX(h_box), button , 0, TRUE , 0);

    gtk_table_attach_defaults(GTK_TABLE(g_table),h_box ,
                                0 , 3 , list_length + 2 , list_length + 3);

    gtk_widget_show_all(g_table);

    gtk_container_add(GTK_CONTAINER(align),g_table);

    gtk_object_set_data(GTK_OBJECT(align),"my_gtable",g_table);

return align;
}
