#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>


#include <dbui-defs.h>

#include <dbui-structs.h>

#include <dbui-prototypes.h>

#include "function_prototypes.h"

void
delete_comobo_entry(gpointer data);

void
button_press(GtkWidget *widget, GdkEvent *event);

DBUI_COMBO_ENTRY *
create_new_combo_entry()
{
    DBUI_COMBO_ENTRY	*entry;

    entry = (DBUI_COMBO_ENTRY *)malloc(sizeof(DBUI_COMBO_ENTRY));

    entry->entry = gtk_entry_new(); 

    entry->hbox = gtk_hbox_new(FALSE, 0);

    gtk_box_pack_start(GTK_BOX(entry->hbox),
			entry->entry,
			1 , 1 ,0 );

    entry->button = gtk_button_new_with_label("...");

    gtk_box_pack_start(GTK_BOX(entry->hbox),
			entry->button,
			1 , 1 ,0 );


    entry->popup_menu = gtk_menu_new(); 

    gtk_signal_connect_object (GTK_OBJECT (entry->button),"button_press_event",
			GTK_SIGNAL_FUNC (button_press), 
			GTK_OBJECT (entry->popup_menu));

    gtk_widget_show(entry->button);


    gtk_object_set_data(GTK_OBJECT(entry->hbox),"ENTRY",entry->entry);

    gtk_object_set_data(GTK_OBJECT(entry->hbox),"BUTTON",entry->button);

    gtk_object_set_data(GTK_OBJECT(entry->hbox),"POPUP_MENU",entry->popup_menu);

    gtk_object_set_data_full(GTK_OBJECT(entry->hbox),"DBUI_COMBO_ENTRY",entry,
		(GtkDestroyNotify)delete_comobo_entry);

    gtk_widget_show_all(entry->hbox);

    return entry;
}

void
append_combo_menu_option(GtkWidget *menu,char *option_string,
			gpointer object,void *func)
{
    GList	*g_l = NULL;
    GtkWidget	*menu_item;

    menu_item = gtk_menu_item_new_with_label(option_string);

    if(!menu_item)
	return ;

    gtk_menu_append (GTK_MENU (menu),menu_item);

    gtk_signal_connect (GTK_OBJECT (menu_item), "activate",
				GTK_SIGNAL_FUNC(func),
				(gpointer)object); 

    g_l = gtk_object_get_data(GTK_OBJECT(menu),"MENU_LIST");

    if(!g_l)
	{
	g_l = g_list_append(g_l,menu_item);
	gtk_object_set_data_full(GTK_OBJECT(menu),"MENU_LIST",g_l,
			(GtkDestroyNotify)g_list_free);
	}
    else
	g_list_append(g_l,menu_item);

    gtk_object_set_data(GTK_OBJECT(menu),option_string,menu_item);

    gtk_widget_show(menu_item);
}

void
button_press(GtkWidget *widget, GdkEvent *event)
{

         if (event->type == GDK_BUTTON_PRESS) {
             GdkEventButton *bevent = (GdkEventButton *) event; 
             gtk_menu_popup (GTK_MENU (widget), NULL, NULL, NULL, NULL,
                             bevent->button, bevent->time);
             /* Tell calling code that we have handled this event; the buck
              * stops here. */
             return ;
         }

         /* Tell calling code that we have not handled this event; pass it on. */
         return ;

}

void   
delete_comobo_entry(gpointer data)
{	
     free(data);
}
