#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>


#include <dbui-defs.h>

#include <dbui-structs.h>

#include "create_table_ui.h"
#include "create_tree_entry.h"
#include "select_tree_item_callback.h"
#include "table_functions.h"

#include "function_prototypes.h"

GtkWidget *
create_query_window(TABLE	*database,TABLE	*table,char	*sql_command)
{
    TABLE	*cur_database = NULL;
    TABLE	*cur_table = NULL;
    GtkWidget	*window = NULL;
    GtkWidget	*check_box = NULL;
    GtkWidget	*text_entry = NULL;
    GtkWidget	*button = NULL;
    GtkWidget	*vbox = NULL;
    GtkWidget	*hbox = NULL;

    if(!database)
	return NULL;

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

    vbox = gtk_vbox_new(FALSE,5);

    hbox = gtk_hbox_new(TRUE,5);

    check_box = gtk_check_button_new_with_label("Create result window");

    text_entry = gtk_text_new(NULL,NULL);

    gtk_text_set_editable(GTK_TEXT(text_entry),TRUE);

    if(sql_command)
	gtk_text_insert(GTK_TEXT(text_entry),NULL,NULL,NULL,sql_command,-1);

    button = gtk_button_new_with_label("Execute Query");  

    gtk_signal_connect (GTK_OBJECT(button),"clicked",
		GTK_SIGNAL_FUNC(exec_callback), NULL);

    cur_database = create_new_table(database->name,database->my_connect,NULL);

    if(table)
	cur_table = create_new_table(table->name,table->my_connect,database);
    else
	cur_table = create_new_table("Unknown",database->my_connect,database);

    gtk_object_set_data_full(GTK_OBJECT(button),"DATABASE",cur_database,delete_table);

    gtk_object_set_data_full(GTK_OBJECT(button),"TABLE",cur_table,delete_table);

    gtk_object_set_data(GTK_OBJECT(button),"CHECK_BOX",check_box);

    gtk_object_set_data(GTK_OBJECT(button),"TEXT_ENTRY",text_entry);

    gtk_box_pack_start(GTK_BOX(hbox),check_box,TRUE,FALSE,0);

    gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,0);

    gtk_box_pack_start(GTK_BOX(vbox),text_entry,TRUE,TRUE,0);

    gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);

    gtk_container_add(GTK_CONTAINER(window),vbox);

    gtk_widget_set_usize(GTK_WIDGET(window),400,260);

    gtk_widget_show_all(window);

    return window;
}
