#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>


#include <dbui-defs.h>

#include <dbui-structs.h>

#include "function_prototypes.h"

static int
col_compare_func(gconstpointer a,gconstpointer b);

static void
process_clist_request(TABLE *tab,CLIST_REQUEST *cl_req,GtkCTree	*ctree);


void
select_tree_item_callback       (GtkCList *clist,int row,int col , 
				GdkEventButton *event, gpointer data)
{
    TABLE	*table;
    GtkWidget	*window = GTK_WIDGET(data) ;
    GtkWidget	*main_window;
    char	*t;
    CLIST_REQUEST *cl_req;

    main_window = gtk_widget_get_toplevel(GTK_WIDGET(window));

    table = gtk_clist_get_row_data(clist,row);

    if(table && table->window)
	{
	change_scrolled_window(window,table->window);
	}

    if(main_window)
	{
	cl_req = gtk_object_get_data(GTK_OBJECT(main_window),"CLIST_REQUEST");	

	process_clist_request(table,cl_req,GTK_CTREE(clist));
	}
}

static void
process_clist_request(TABLE *tab,CLIST_REQUEST *cl_req,GtkCTree	*ctree)
{
    DBUI_COMBO_ENTRY *combo_entry = NULL;
    GtkWidget	*hbox = NULL;
    GtkWidget	*g_align = NULL;
    GtkWidget	*g_table = NULL;
    GtkCTreeNode *parent = NULL;
    GtkMenuItem	*menu_item = NULL;
    COLUMN	*col = NULL;
    COLUMN	*equal_col = NULL;
    COLUMN	*new_col = NULL;
    TABLE	*parent_table = NULL;
    TABLE	*new_parent_table = NULL;
    TABLE	*new_table = NULL;
    GList	*g_l = NULL;
    GList	*entry_list = NULL;
    int		row = 0;



    if(cl_req->type == NO_REQUEST)
	return;

    switch(cl_req->type)
	{
	case SET_EQ_COL:
	  if(tab->tables || tab->col_set)
	    {
	    cl_req->type = NO_REQUEST;
	    cl_req->requester = NULL;
	    return;
	    }

	  parent_table = tab->parent;

	  combo_entry = (DBUI_COMBO_ENTRY *)cl_req->requester;

	  menu_item = (GtkMenuItem *)cl_req->spare1;

	  hbox = combo_entry->hbox;

	  col = gtk_object_get_data(GTK_OBJECT(hbox),"COLUMN");

	  if(parent_table && parent_table->col_set)
	    {
	    g_l = g_list_find_custom(parent_table->col_set,tab,
						col_compare_func);
	    if(g_l && g_l->data)
		{
		mark_popup_menu(GTK_WIDGET(menu_item),TRUE);
		equal_col = (COLUMN *)g_l->data;
		col->equal_col = copy_column(equal_col);
		}			
	    }
	break;

	case ADD_FIELD:
	  if(tab->tables || tab->col_set)
	     {
     	       cl_req->type = NO_REQUEST;
	       cl_req->requester = NULL;
               return;
	     }

           parent_table = tab->parent;

          if(parent_table && parent_table->col_set)
            {
            g_l = g_list_find_custom(parent_table->col_set,tab,
                                                col_compare_func);
            if(g_l && g_l->data)
                {

		col = g_l->data;

		new_col = copy_column(col);

		new_col->equal_col = NULL;

		new_parent_table = cl_req->requester;					
		g_align = new_parent_table->window;

		if(g_align)
		  g_table = gtk_object_get_data(GTK_OBJECT(g_align),"my_table");

		new_col->table = new_parent_table;

		entry_list = gtk_object_get_data(GTK_OBJECT(g_table),"ENTRY_LIST");
		
		row = g_list_length(entry_list);

		create_entry_field(new_col,g_table,row + 1);

		gtk_widget_show_all(g_table);

		parent = cl_req->spare1;		

		g_list_append(new_parent_table->col_set,new_col);

		new_table = create_new_table(tab->name,tab->my_connect,new_parent_table);

		new_table->my_col = new_col;

		new_table->menu_type = FIELD_MENU;

		create_tree_entry(ctree,parent,NULL,new_table);

		}

	    }

	break;

	default:
	  cl_req->type = NO_REQUEST;
	break;
	}

    cl_req->type = NO_REQUEST;
    cl_req->requester = NULL;
    cl_req->spare1 = NULL;

}

static int
col_compare_func(gconstpointer a,gconstpointer b)
{
    COLUMN	*col_a = (COLUMN *)a;
    TABLE	*tab_b = (TABLE *)b;
    char	name[NAME_LENGTH];

    if(col_a && tab_b)
	{
	sprintf(name,"%s.%s",col_a->parent_name,col_a->name);
	if(!strncmp(name,tab_b->name,NAME_LENGTH))
	  return 0;	
	}
    return 1;
}
