#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>

#include <dbui-defs.h>

#include <dbui-structs.h>

#include <mysql/mysql.h>

#include <mysql-prototypes.h>

#include "../gui/function_prototypes.h"

GList *
mysql_exec_query(TABLE	*database, TABLE	*table, char	*query)
{
    MYSQL_RES	*result_set;
    MYSQL_ROW	row;
    MYSQL_FIELD	*fields;
    CONNECTION  *connect;
    COLUMN	*col;
    GList	*col_values;
    GList	*results = NULL;
    int         num_rows;
    int		num_fields;
    int         i,j;

    connect = database->my_connect;

    if(! mysql_select_db((MYSQL *)connect->handle,database->name) )
	{
	printf("Execing %s\n",query);
        fflush(stdout);
	if( mysql_real_query((MYSQL *)connect->handle , query, strlen(query) ))
	  {
	  printf("SQL error %s\n",mysql_error((MYSQL *)connect->handle));
	  return NULL;
	  }

	result_set = mysql_store_result((MYSQL *)connect->handle);

	if(!result_set )
	  {
	  return NULL;
	  }

	num_rows = mysql_num_rows(result_set);

	num_fields = mysql_num_fields(result_set);

	fields = mysql_fetch_fields(result_set);

	for(i = 0 ; i < num_rows; i++ )
	  {

	    row = mysql_fetch_row(result_set);

	    col_values = NULL;

	    for(j = 0 ; j < num_fields ; j++)
	      {
		col = create_new_col(fields[j].name,table);

		if(fields[j].table)
		  strncpy(col->parent_name,fields[j].table,NAME_LENGTH);

		col->type = mysql_change_type_to_dbui(fields[j].type);

		col->size = fields[i].length;

		if(row[j])
		  {
		  col->value = (char *)calloc(
				( strlen( row[j] ) + 1 ) , sizeof(char) );

		  strcpy(col->value,row[j]);
		  }
		else
		  col->value = NULL;

		col_values = g_list_append(col_values , col);
	      }

	  results = g_list_append(results , col_values);

	  }

	mysql_free_result(result_set);
	} 

    return results;
}
