#include <gtk/gtk.h>
   
#include <stdio.h>      
#include <string.h>
    
#include <dbui-defs.h>
    
#include <dbui-structs.h>

#include <mysql-prototypes.h>

static GList	*build_list_entry(GList	*field_list,
		char	*field_name,
		int	dbui_type);

void
mysql_load_driver()
{
    COLUMN	*col;
    GList	*field_list = NULL;
    DRIVER	*driver;

    driver = (DRIVER *)malloc(sizeof(DRIVER));

    strncpy(driver->name,"MYSQL",NAME_LENGTH);

    driver->login = mysql_login;

    driver->free_connection = mysql_free_connection;

    driver->build_databases = mysql_build_databases;

    driver->build_database = mysql_build_database;

    driver->build_table = mysql_build_table;

    driver->exec_search = mysql_exec_search;

    driver->exec_insert = mysql_exec_insert;

    driver->exec_delete = mysql_exec_delete;

    driver->exec_update = mysql_exec_update;

    driver->exec_query = mysql_exec_query;

    field_list = build_list_entry(field_list,"Hostname",DBUI_VARCHAR);

    field_list = build_list_entry(field_list,"Username",DBUI_VARCHAR);
    
    field_list = build_list_entry(field_list,"Password",DBUI_VARCHAR);
    
    field_list = build_list_entry(field_list,"Database",DBUI_VARCHAR);
    
    field_list = build_list_entry(field_list,"Port",DBUI_VARCHAR);

    field_list = build_list_entry(field_list,"Unix sock",DBUI_VARCHAR);

    driver->fields = field_list;

    driver_list = g_list_append(driver_list,driver);
}


static GList    *build_list_entry(GList *field_list,
                char    *field_name,
                int     dbui_type)
{
    COLUMN	*col;

    col = (COLUMN *)malloc(sizeof(COLUMN));

    strncpy( col->name, field_name, NAME_LENGTH);

    strcpy(col->parent_name,"MYSQL");

    col->table = NULL;

    col->type = dbui_type;

    col->compair_type = 0;

    col->need_compair_type = 0;

    col->size = 32;

    col->value = NULL;

    col->need_quote = 0;

    field_list = g_list_append(field_list,col);

    return field_list;
}
