#include <gtk/gtk.h>
 
#include <stdio.h>
#include <string.h>
    
#include <dbui-defs.h>
    
#include <dbui-structs.h>

#include <dbui-prototypes.h>
   
#include <libpq-fe.h>
 
#include <postgres-prototypes.h>

#include "../gui/function_prototypes.h"


void
postgres_build_table(TABLE	*table)
{
    PGresult	*result_set;
    CONNECTION	*connect;
    TABLE	*database;
    TABLE	*col_tab;
    COLUMN	*col;
    GList	*table_cols = NULL;
    GList	*col_set = NULL;
    char	show_query[2048];
    char	full_name[NAME_LENGTH];
    char	*col_name;
    char	*type;
    int		dbui_type = 0;
    int		num_rows;
    int		i;

    connect = table->my_connect;

    database = table->parent;

    bzero(show_query,2048);

    snprintf(show_query,2048,"select att.attname,att.atttypid from pg_attribute as att,pg_class as cl where att.attrelid = cl.oid and cl.relname = '%s' and att.attnum > 0 ",table->name);

    result_set = PQexec(connect->handle,show_query);

    if(!result_set )
	{
	return;
	}	

    if(PQresultStatus(result_set) != PGRES_TUPLES_OK)
	{
	PQclear(result_set);

	return;
	}

	num_rows = PQntuples(result_set);

	for(i = 0 ; i < num_rows ; i++)
		{
		bzero(full_name,NAME_LENGTH);

		col_name = PQgetvalue(result_set,i,0);

		type = PQgetvalue(result_set,i,1);

		if(type)
		  dbui_type = strtol(type,NULL,10);

		snprintf(full_name,NAME_LENGTH,"%s.%s",table->name,
			col_name);

		col_tab = create_new_table(full_name,connect,table);

		col_tab->menu_type = NO_MENU;

		col_tab->parent = table;
		
		col = create_new_col(col_name,table);

		col_tab->my_col = col;

		col->type = postgres_change_type_to_dbui(dbui_type);

		col->need_compair_type = 1;

		col_set = g_list_append(col_set,col);

		table_cols = g_list_append(table_cols,col_tab);
		}

	table->tables = table_cols;

        table->col_set = col_set;

	PQclear(result_set);
    

}
